using System;
using System.Reflection;

namespace Smdn.Applications.SimpleHalt {
  public static class PropertyInfoExtensions {
    public static TAttribute GetSingleCustomAttribute<TAttribute>(this PropertyInfo property) where TAttribute : Attribute
    {
      var attrs = property.GetCustomAttributes(typeof(TAttribute), true);

      if (attrs == null || attrs.Length <= 0)
        return null;
      else
        return attrs[0] as TAttribute;
    }
  }
}
